# Create a new user POST https://app.unleash-instance.example.com/api/admin/user-admin Content-Type: application/json Creates a new user with the given root role. Reference: https://docs.getunleash.io/api/create-user ## OpenAPI Specification ```yaml openapi: 3.1.1 info: title: Create a new user version: endpoint_users.createUser paths: /api/admin/user-admin: post: operationId: create-user summary: Create a new user description: Creates a new user with the given root role. tags: - - subpackage_users parameters: - name: Authorization in: header description: Header authentication of the form `undefined ` required: true schema: type: string responses: '201': description: The resource was successfully created. content: application/json: schema: $ref: '#/components/schemas/createUserResponseSchema' '400': description: The request data does not match what we expect. content: {} '401': description: >- Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. content: {} '403': description: >- The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation content: {} requestBody: description: createUserSchema content: application/json: schema: $ref: '#/components/schemas/createUserSchema' components: schemas: CreateUserSchemaRootRole1: type: string enum: - value: Admin - value: Editor - value: Viewer - value: Owner - value: Member - value: Reader CreateUserSchemaRootRole: oneOf: - type: integer - $ref: '#/components/schemas/CreateUserSchemaRootRole1' createUserSchema: type: object properties: username: type: string description: The user's username. Must be provided if email is not provided. email: type: string description: >- The user's email address. Must be provided if username is not provided. name: type: string description: The user's name (not the user's username). password: type: string description: Password for the user rootRole: $ref: '#/components/schemas/CreateUserSchemaRootRole' description: >- The role to assign to the user. Can be either the role's ID or its unique name. sendEmail: type: boolean description: >- Whether to send a welcome email with a login link to the user or not. Defaults to `true`. required: - rootRole CreateUserResponseSchemaRootRole1: type: string enum: - value: Admin - value: Editor - value: Viewer - value: Owner - value: Member - value: Reader CreateUserResponseSchemaRootRole: oneOf: - type: integer - $ref: '#/components/schemas/CreateUserResponseSchemaRootRole1' CreateUserResponseSchemaAccountType: type: string enum: - value: User - value: Service Account createUserResponseSchema: type: object properties: id: type: integer description: The user id name: type: - string - 'null' description: Name of the user email: type: string description: Email of the user username: type: - string - 'null' description: A unique username for the user imageUrl: type: string description: URL used for the user profile image inviteLink: type: string description: >- If the user is actively inviting other users, this is the link that can be shared with other users loginAttempts: type: integer description: How many unsuccessful attempts at logging in has the user made emailSent: type: boolean description: Is the welcome email sent to the user or not rootRole: $ref: '#/components/schemas/CreateUserResponseSchemaRootRole' description: >- Which [root role](https://docs.getunleash.io/concepts/rbac#predefined-roles) this user is assigned. Usually a numeric role ID, but can be a string when returning newly created user with an explicit string role. seenAt: type: - string - 'null' format: date-time description: The last time this user logged in createdAt: type: string format: date-time description: The user was created at this time accountType: $ref: '#/components/schemas/CreateUserResponseSchemaAccountType' description: A user is either an actual User or a Service Account permissions: type: array items: type: string description: Deprecated scimId: type: - string - 'null' description: The SCIM ID of the user, only present if managed by SCIM seatType: type: - string - 'null' description: The seat type of this user companyRole: type: - string - 'null' description: The role of the user within the company. productUpdatesEmailConsent: type: - boolean - 'null' description: Whether the user has consented to receive product update emails. activeSessions: type: - integer - 'null' description: Count of active browser sessions for this user deletedSessions: type: number format: double description: >- Experimental. The number of deleted browser sessions after last login required: - id ``` ## SDK Code Examples ```python import requests url = "https://app.unleash-instance.example.com/api/admin/user-admin" payload = { "rootRole": "Admin" } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/user-admin'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"rootRole":"Admin"}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/user-admin" payload := strings.NewReader("{\n \"rootRole\": \"Admin\"\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/user-admin") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"rootRole\": \"Admin\"\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/admin/user-admin") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"rootRole\": \"Admin\"\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/admin/user-admin', [ 'body' => '{ "rootRole": "Admin" }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/user-admin"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"rootRole\": \"Admin\"\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = ["rootRole": "Admin"] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/user-admin")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```